﻿DKFight = LibStub("AceAddon-3.0"):NewAddon("DKFight", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("DKFight")

-- Spell Data
DKFight.spells = {
	["Icy Touch"] 		= GetSpellInfo(45477),
	["Plague Strike"] 	= GetSpellInfo(45462),
	["Scourge Strike"] 	= GetSpellInfo(55265),
	["Blood Strike"] 	= GetSpellInfo(45902),
	["Death Coil"] 		= GetSpellInfo(52375),
	["Obliterate"] 		= GetSpellInfo(49020),
	["Heart Strike"] 	= GetSpellInfo(55258),
	["Howling Blast"] 	= GetSpellInfo(51408),
	["Frost Strike"] 	= GetSpellInfo(51416),
	--Procs							
	["Rime"]			= {
							type = "Proc",
							info = GetSpellInfo(59052),
							displayFrame = nil,
							frameName = "RimeFrame",
							texturePath = "Interface/Icons/Spell_Frost_FreezingBreath",
							texture = nil,
							detectKey = "Rime",
							state = false,
							duration = 15,
							timer = nil,
							resetCB = function()
								if DKFight.db.profile.Output == 3 then
									DKFight.spells["Rime"].displayFrame:SetCooldown(GetTime(), 0)
									DKFight:CancelTimer(DKFight.spells["Rime"].timer, true)
								end
								DKFight.spells["Rime"].state = false
								end
						},
	["Killing Machine"]	= {
							type = "Proc",
							info = GetSpellInfo(51124),
							displayFrame = nil,
							frameName = "KillingMachineFrame",
							texturePath = "Interface/Icons/Inv_Sword_122",
							texture = nil,
							detectKey = "KM",
							state = false,
							duration = 30,
							timer = nil,
							resetCB = function()
								if DKFight.db.profile.Output == 3 then
									DKFight.spells["Killing Machine"].displayFrame:SetCooldown(GetTime(), 0)
									DKFight:CancelTimer(DKFight.spells["Killing Machine"].timer, true)
								end
								DKFight.spells["Killing Machine"].state = false
								end
						},
	["Sudden Doom"]		= {
							type = "Proc",
							info = GetSpellInfo(50466),
							frameName = "SuddenDoomFrame",
							texturePath = "Interface/Icons/Spell_Shadow_DeathCoil",
							texture = nil,
							displayFrame = nil,
							detectKey = "SD",
							state = false,
							duration = 15,
							timer = nil,
							resetCB = function() 
								if DKFight.db.profile.Output == 3 then
									DKFight.spells["Sudden Doom"].displayFrame:SetCooldown(GetTime(), 0)
									DKFight:CancelTimer(DKFight.spells["Sudden Doom"].timer, true)
								end
								DKFight.spells["Sudden Doom"].state = false
								end
						},
	["Unholy Strength"]	= {
							type = "Proc",
							info = GetSpellInfo(53365),
							frameName = "UnholyStrengthFrame",
							texturePath = "Interface/Icons/Spell_Holy_BlessingOfStrength",
							texture = nil,
							displayFrame = nil,
							detectKey = "US",
							state = false,
							duration = 15,
							timer = nil,
							resetCB = function()
								if DKFight.db.profile.Output == 3 then
									DKFight.spells["Unholy Strength"].displayFrame:SetCooldown(GetTime(), 0)
									DKFight:CancelTimer(DKFight.spells["Unholy Strength"].timer, true)
								end
								DKFight.spells["Unholy Strength"].state = false
								end
						},
	["Mirror of Truth"] = {
							type = "Proc",
							info = GetSpellInfo(60065),
							frameName = "MirrorOfTruthFrame",
							texturePath = "Interface/Icons/Ability_Rogue_SinisterCalling",
							texture = nil,
							displayFrame = nil,
							detectKey = "MoT",
							state = false,
							duration = 10,
							timer = nil,
							resetCB = function()
								if DKFight.db.profile.Output == 3 then
									DKFight.spells["Mirror of Truth"].displayFrame:SetCooldown(GetTime(), 0)
									DKFight:CancelTimer(DKFight.spells["Mirror of Truth"].timer, true)
								end
								DKFight.spells["Mirror of Truth"].state = false
								end
						},
	--Pet
	["Gnaw"]			= {
							type = "Pet",
							info = GetSpellInfo(47481),
							frameName = "GnawFrame",
							texturePath = "Interface/Icons/Spell_DeathKnight_Gnaw_Ghoul",
							texture = nil,
							displayFrame = nil,
							detectKey = "Gnaw",
							state = false,
							duration = 20,
							timer = nil,
							resetCB = function()
								if DKFight.db.profile.Output == 3 then
									DKFight.spells["Gnaw"].displayFrame:SetCooldown(GetTime(), 0)
									DKFight:CancelTimer(DKFight.spells["Gnaw"].timer, true)
								end
								DKFight.spells["Gnaw"].state = false
								end
						},
	--Reactive
	["Rune Strike"] 	= {	
							type = "Reactive",
							info = GetSpellInfo(56815),
							displayFrame = nil,
							frameName = "RuneStrikeFrame",
							texturePath = "Interface/Icons/Spell_DeathKnight_DarkConviction",
							texture = nil,
							detectKey = "RS",
							state = false,
							duration = 0,
							timer = nil,
							resetCB = function() 
								if DKFight.db.profile.Output == 3 then
									DKFight.spells["Rune Strike"].displayFrame:SetCooldown(GetTime(), 0)
									DKFight:CancelTimer(DKFight.spells["Rune Strike"].timer, true)
								end
								DKFight.spells["Rune Strike"].state = false
								end
						},
}
function DKFight:InitOptions()
	self.options = {}
	
	function Options()
		return {
			type = "group",
			name = L["DKFight"],
			handler = DKFight,
			args = {
				-- TABS
				general = {
					type = "group",
					name = L["WTF IS THIS"],
					args = {
						description = {
							type = "description",
							name = L["Helps Death Knights to optimize damage output. Notifies the player when important short duration, commonly overlooked, buffs are applied, and helps the player get into a rotation of abilities to increase DPS."],
							order = 1
						},
						main = {
							type = "group",
							name = L["General Options"],
							inline = true,
							args = {
								show = {
									type = "toggle",
									name = "Show",
									desc = "Hide / Show the frame",
									set = "SetShow",
									get = "GetShow",
									order = 1
								},
								locked = {
									type = "toggle",
									name = "Locked",
									desc = "Lock / Unlock the frame",
									set = "SetLocked",
									get = "GetLocked",
									order = 2
								},
								breakMain = {
									type = "header",
									name = "",
									order = 3
								},
								descriptionColor = {
									type = "description",
									name = L["Adjust the default background color and faded background color.  The faded color is used when debuffs are about to expire."],
									order = 7,
								},
								background = {  
									type = "color", 
									name = "Background",
									desc = "Sets the background color of the main frame.",
									get = "GetBackground",
									set = "SetBackground",
									hasAlpha = true,
									order = 8
								},
								faded = { 
									type = "color", 
									name = "Faded",
									desc = "Sets the faded color of the main frame. NOT WORKING",
									get = "GetFaded",
									set = "SetFaded",
									hasAlpha = true,
									order = 9
								}
							}
						}
					}	
				},
				detection = {
					type = "group",
					name = L["WTF IS THIS"],
					args = {
						description = {
							type = "description",
							name = L["Set what you want detected, and how it should be displayed."],
							order = 1
						},
						detections = {
									type = "multiselect",
									name = L["Enable detection"],
									values = {["Rime"]="Rime", ["KM"]="Killing Machine", ["SD"]="Sudden Doom", ["RS"]="Rune Strike", ["US"]="Unholy Strength", ["MoT"]="Mirror of Truths", ["Gnaw"]="Pet: Gnaw" },
									set = function(info, key, state)
											self.db.profile.outputEnabled[key] = state;
											end,
									get = function(info, key)
											return self.db.profile.outputEnabled[key];
										end,
									order=2
						},
						output = {
									type = "select",
									name = L["Output to"],
									values = { L["Chat Frame"], L["Error Message"], L["DK Fight Frame"]},
									set = "SetOutput",
									get = "GetOutput",
									order = 3
						}
					}	
				},
				rotation = {
					type = "group",
					name = L["WTF IS THIS"],
					args = {
						description = {
							type = "description",
							name = L["Empty Stub.  Under Development :)"],
							order = 1
						}
					}
				}
			},
		}
	end
	
	self.options = Options();
	-- Set up options and configuration dialog.
	LibStub("AceConfig-3.0"):RegisterOptionsTable(L["DK Fight"], self.options)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	
	self.config = {}
	self.config.options = options
	self.config.general = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(L["DK Fight"], nil, nil, 'general')
	self.config.detection = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(L["DK Fight"], L["Detection"], L["DK Fight"], 'detection')
	self.config.rotation = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(L["DK Fight"], L["Rotation"], L["DK Fight"], 'rotation')
	self.config.profiles = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Profiles", "Profiles", L["DK Fight"])
	
	self:RegisterChatCommand("dkfight", "ChatCommand")
	self:RegisterChatCommand("dkf", "ChatCommand")
end

-- Event Handlers
function DKFight:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.config.general)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(DKFight, "dkp", "DKFight", input)
	end
end

-- MUTATORS / ACCESSORS
function DKFight:SetShow(info, v)
	self.db.profile.show = v;
	self:UpdateVisible();
end

function DKFight:GetShow(info)
	return self.db.profile.show;
end

function DKFight:SetLocked(info, v)
	self.db.profile.locked = v;
	self:UpdateDisplay();
end

function DKFight:GetLocked(info)
	return self.db.profile.locked;
end

function DKFight:SetScale(info, v)
	self.db.profile.scale = v;
	self:UpdateDisplay();
end

function DKFight:GetScale(info)
	return self.db.profile.scale;
end

function DKFight:SetBackground(info, r, g, b, a)
	self.db.profile.colors.background = {r = r, g = g, b = b, a = a}
	self:UpdateDisplay();							
end

function DKFight:GetBackground(info)
	local color = self.db.profile.colors.background
	return color.r, color.g, color.b, color.a								
end

function DKFight:SetFaded(info, r, g, b, a)
	self.db.profile.colors.faded = {r = r, g = g, b = b, a = a}
	self:UpdateDisplay();						
end

function DKFight:GetFaded(info)
	local color = self.db.profile.colors.faded
	return color.r, color.g, color.b, color.a								
end

function DKFight:SetRimeEnabled(info, v)
	self.db.profile.rimeEnabled = v;
end

function DKFight:GetRimeEnabled(info)
	return self.db.profile.rimeEnabled;
end

function DKFight:SetKMEnabled(info, v)
	self.db.profile.kmEnabled = v;
end

function DKFight:GetKMEnabled(info)
	return self.db.profile.kmEnabled;
end

function DKFight:SetSDEnabled(info, v)
	self.db.profile.sdEnabled = v;
end

function DKFight:GetSDEnabled(info)
	return self.db.profile.sdEnabled;
end

function DKFight:SetRSEnabled(info, v)
	self.db.profile.rsEnabled = v;
end

function DKFight:GetRSEnabled(info)
	return self.db.profile.rsEnabled;
end

function DKFight:GetUSEnabled(info)
	return self.db.profile.usEnabled;
end						

function DKFight:SetUSEnabled(info, v)
	self.db.profile.usEnabled = v;
end

function DKFight:GetMoTEnabled(info)
	return self.db.profile.MoTEnabled;
end

function DKFight:SetMoTEnabled(info, v)
	self.db.profile.MoTEnabled = v;
end

function DKFight:GetGnawEnabled(info)
	return self.db.profile.GnawEnabled;
end
	
function DKFight:SetGnawEnabled(info, v)
	self.db.profile.GnawEnabled = v;
end

function DKFight:SetOutput(info, v)
	self.db.profile.Output = v;
end

function DKFight:GetOutput(info)
	return self.db.profile.Output;
end