﻿DKFight = LibStub("AceAddon-3.0"):GetAddon("DKFight")
local L = LibStub("AceLocale-3.0"):GetLocale("DKFight")

local defaults = {
	profile = {
		-- Saved Variables
		show = true,
		warn = true,
		locked = false,
		scale = 1.0,
		strata = "BACKGROUND",
		rimeEnabled = true,
		outputEnabled = { },
		Output = {L["DK Fight Frame"]},
		x = 0,
		y = 0,
		w = 210,
		h = 60,
		colors = {
			background = { r = 0.0, g = 0.0, b = 0.0, a = 0.75 },
			warn = { r = 0.75, g = 0.0, b = 0.0, a = 0.75 },
			faded = { r = 0.0, g = 0.0, b = 0.0, a = 0.20 }
		},
		-- Unsaved Variables
		enabled = true,
		relTo = "CENTER",
		relPt = "CENTER",
		isDKFight = true,
		isDKWarning = false,
		Anchor = nil,
		Display = nil,
		Grip = nil,
		tooltip = "",
		optionsFrame = nil,
		isShowingTooltip = false,
		timeSinceDKFight = 0,
    },
}

function DKFight:OnInitialize()
	-- Load the saved variables.
	self.db = LibStub("AceDB-3.0"):New("DKFightDB", defaults, "Default")
	
	-- Init the options.
	self:InitOptions();

	-- Create the display frame for the user.
	self:CreateFrame();
end

function DKFight:OnEnable()
    	-- Called when the addon is enabled
	self:RegisterEvent("UNIT_AURA")
end

function DKFight:OnDisable()
    	-- Called when the addon is disabled
end

-- EVENT HANDLERS
function DKFight:UNIT_AURA()
	-- Buff Checking
	for spell,details in pairs(self.spells) do
		if spell ~= details and details.info ~= nil and self.db.profile.outputEnabled[details.detectKey] then
			if details.type == "Proc" then
				if UnitBuff("player", details.info) then
					-- Check to make sure the buff is not currently known to be active.
					if not details.state then
						-- OUTPUT TYPES
						-- 1 = Chat
						if self.db.profile.Output == 1 then
							self:Print(spell .. "!")
						-- 2 = Raid Warning
						elseif self.db.profile.Output == 2 then
							UIErrorsFrame:AddMessage(spell .. "!", 1.0, 0.0, 0.0, 53, 5)
						-- 3 = Icon
						elseif self.db.profile.Output == 3 then
							details.displayFrame:SetCooldown(GetTime(), details.duration)
							details.timer = self:ScheduleTimer(details.resetCB, details.duration)
						end
					end
					-- Timer is set, don't come back in here
					details.state = true
				else
					details.resetCB()
				end
			elseif details.type == "Pet" then
				local start, duration = GetSpellCooldown(details.info)
				--When the duration is 0, the ability is good to go!
				if duration ~= 0 then
					if not details.state then
						if self.db.profile.Output == 1 then
							self:Print(spell .. "!")
						elseif self.db.profile.Output == 2 then
							UIErrorsFrame:AddMessage(spell .. "!", 1.0, 0.0, 0.0, 53, 5)
						elseif self.db.profile.Output == 3 then
							details.displayFrame:SetCooldown(start, duration)
							details.timer = self:ScheduleTimer(details.resetCB, duration)
						end
					end
					-- Timer is set, don't come back in here
					details.state = true
				else
					details.resetCB()
				end
			elseif details.type == "Reactive" then
				--self:Print("Reactive")
			end
		end
	end
end